<?php
	require_once("connexionBDD.inc.php");
	require_once("clientTCPIP.inc.php");
	require_once("CElement.inc.php");
	require_once("CCompte.inc.php");
	
	Class Persistance
	{
		/********************************************
			Attribut de la classe Marque
		********************************************/
		/********************************************
			Données pour l'acces mysql à la base de données WEBCARE
		********************************************/
		private $ipWEBCARE;
		private $userWEBCARE;
		private $passwordWEBCARE;
		private $nomBDDWEBCARE;

		/********************************************
			Données pour l'acces mysql à la base de données SG7
		********************************************/
		private $ipSG7;
		private $userSG7;
		private $passwordSG7;
		private $nomBDDSG7;
		
		/********************************************
			Données pour l'acces tcpip à l'applet Risque
		********************************************/
		private $ipServCmd;
		private $portServCmd;

		/********************************************
		*	Constructeur de la Classe Marque
		*
		********************************************/
		public function Persistance()
		{
			$this->id = null;
			$this->libelle = null;
		}
		/********************************************
		*
		*	Accesseur de la classe Marque
		*
		********************************************/
		public function __get($propriete)
		{
			if(isset($this->$propriete))
			{
				return $this->$propriete;
			}
			else
			{
				return "Attributs invalide";
			}
		}
		public function __set($propriete, $valeur)
		{
				$this->$propriete = $valeur;
		}		
		
		/********************************************
			Méthode	:	chargerParamBDDWEBCARE
				récupère les paramètre de connexion à la base WEBCARE
		********************************************/
		private function chargerParamBDDWEBCARE()
		{
			$conn= new connexionBDD("localhost","T2I","T2II2T");
			$db=$conn->connexion();
			mysql_select_db("CONFIG_WEBCARE",$db);
			$requete="SELECT ip,user,password,nomBDD FROM CONFIG_BDD WHERE libelleBDD='WEBCARE';";
			$resultat = mysql_query($requete) or die("Erreur :".mysql_error());
			$i=0;
			while($row = mysql_fetch_array($resultat))
			{
				$this->ipWEBCARE=$row[0];
				$this->userWEBCARE=$row[1];
				$this->passwordWEBCARE=$row[2];
				$this->nomBDDWEBCARE=$row[3];
				$i++;
			}
			$conn->deconnexion($db);
		}
		/********************************************
			Méthode	:	chargerParamBDDBSG7
				récupère les paramètre de connexion à la base BSG7
		********************************************/
		private function chargerParamBDDBSG7()
		{
			$conn= new connexionBDD("localhost","T2I","T2II2T");
			$db=$conn->connexion();
			mysql_select_db("CONFIG_WEBCARE",$db);
			$requete="SELECT ip,user,password,nomBDD FROM CONFIG_BDD WHERE libelleBDD='BSG7';";
			$resultat = mysql_query($requete) or die("Erreur :".mysql_error());
			$i=0;
			while($row = mysql_fetch_array($resultat))
			{
				$this->ipSG7=$row[0];
				$this->userSG7=$row[1];
				$this->passwordSG7=$row[2];
				$this->nomBDDSG7=$row[3];
				$i++;
			}
			$conn->deconnexion($db);
		}

		public function chargerParamTCPIP()
		{
			$conn= new connexionBDD("localhost","soft","hxfr67ds");
			$db=$conn->connexion();
			mysql_select_db("IHM_FE",$db);
			$requete="SELECT ipCMD,portCMD FROM CONFIG";
			$resultat = mysql_query($requete);
			if($row = mysql_fetch_array($resultat))
			{
				$this->ipServCmd=$row[0];
				$this->portServCmd=$row[1];
			}
			$conn->deconnexion($db);
		}

		public function valideCompte($login,$id)
		{
			$oConn = new ConnexionBDD($this->ipWEBCARE,$this->userWEBCARE,$this->passwordWEBCARE);
			$db=$oConn->connexion();
			$resultat=mysql_select_db($this->nomBDDWEBCARE,$db);
			if($resultat!="")
			{
				$requete = "SELECT id FROM COMPTE WHERE login='".$login."' AND id='".$id."';";
				//$requete="SELECT * FROM COMPTE";
				$resultat=mysql_query($requete);
				if($resultat!="")
				{
					if(mysql_num_rows($resultat)==1)
					{
						$row=mysql_fetch_array($resultat);
						if(!$row)
						{
							$resultat="";
						}
						else
						{
							$resultat=$row[0];
						}
					}
					else
					{
						$resultat="0";
					}
					
				}
			}
			return $resultat;		
		}
		public function chargerCompte($oCompte,$id)
		{
			$ret = 0;
			$oConn = new ConnexionBDD($this->ipWEBCARE,$this->userWEBCARE,$this->passwordWEBCARE);
			$db=$oConn->connexion();
			$resultat=mysql_select_db($this->nomBDDWEBCARE,$db);
			if($resultat!==FALSE)
			{
				$requete = "SELECT cpt.id,cpt.description,cpt.login,pro.id,pro.libelle,pro.acces_parc,pro.acces_full_application,pro.acces_service FROM COMPTE AS cpt INNER JOIN PROFIL AS pro ON cpt.id_profil=pro.id WHERE cpt.id=".$id.";";
				$resultat=mysql_query($requete);
				if($resultat!== FALSE)
				{
					if(mysql_num_rows($resultat)==1)
					{
						$row=mysql_fetch_array($resultat);
						if(!$row)
						{
							$ret=-1;
						}
						else
						{
							$oCompte->id = $row[0];
							$oCompte->description = $row[1];
							$oCompte->login=$row[2];
							$oCompte->oProfil = new Profil();
							$oCompte->oProfil->id=$row[3];
							$oCompte->oProfil->libelle=$row[4];
							$oCompte->oProfil->accesParc=$row[5];
							$oCompte->oProfil->accesFullApplications=$row[6];
							$oCompte->oProfil->accesService = $row[7];
							$ret = $oCompte->oProfil->chargerApplications();
							if($ret==0)
							{
								/*$ret = $oCompte->chargerServices();
								if($ret == 0)
								{
									$ret = $oCompte->chargerParcs();
								}*/
							}
						}
					}
					else
					{
						$ret=-1;
					}
					
				}
				else
				{
					$ret = -1;
				}
			}
			else
			{
				$ret = -1;
			}
			return $ret;
		}
		public function chargerApplications($oApplications,$idProfil,$all)
		{
			$ret = 0;
			$oConn = new ConnexionBDD($this->ipWEBCARE,$this->userWEBCARE,$this->passwordWEBCARE);
			$db=$oConn->connexion();
			$resultat=mysql_select_db($this->nomBDDWEBCARE,$db);
			if($resultat!==FALSE)
			{
				if(!$all)
				{
					$clause = "INNER JOIN DROIT AS droit ON app.id=droit.id_application WHERE droit.id_profil =".$idProfil." ";
				}
				else
				{
					$clause="";
				}
				$requete = "SELECT app.id,app.libelle,app.chemin,app.image FROM APPLICATION AS app ".$clause.";";
				$resultat=mysql_query($requete);
				if($resultat!==FALSE)
				{
					$i=0;
					while($row=mysql_fetch_array($resultat))
					{
						$oApplications[$i]=new Application();
						$oApplications[$i]->id=$row[0];
						$oApplications[$i]->libelle=$row[1];
						$oApplications[$i]->chemin=$row[2];
						$oApplications[$i]->image=$row[3];
						$i++;
					}
				}
				else
				{
					$ret = -2;
				}
			}
			else
			{
				$ret = -2;
			}
			return $ret;
		}
		public function recupMaxHisto()
		{
			$conn = new connexionBDD($this->ipWEBCARE,$this->userWEBCARE,$this->passwordWEBCARE);
			$db = $conn->connexion();
			mysql_select_db($this->nomBDDWEBCARE,$db);
			$ret=0;
			$requete = "SELECT MAX(id_historique) FROM HISTORIQUE;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				echo "erreur chargement fil de l'eau";
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$ret=$row[0];
				}
			}
			$conn->deconnexion($db);
			return $ret;
		}
		public function recupLimitElement()
		{
			$conn= new connexionBDD("localhost","T2I","T2II2T");
			$db=$conn->connexion();
			mysql_select_db("CONFIG_WEBCARE",$db);
			$ret=80;
			$requete = "SELECT valeur FROM PARAMETRAGE WHERE nom='nbr_max_elements_fil_eau_webcare';";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				echo "erreur chargement fil de l'eau";
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$ret=$row[0];
				}
			}
			$conn->deconnexion($db);
			return $ret;
		}
		public function chargerCheck(&$pr_in,&$fx_in,&$pr_out,&$fx_out,&$nb_trame,&$nb_trame_max,&$id_last_trame)
		{
			$conn= new connexionBDD("localhost","soft","hxfr67ds");
			$db=$conn->connexion();
			mysql_select_db("IHM_FE",$db);
			$ret=0;
			$requete = "SELECT visu_pr_in,visu_fx_in,visu_pr_out,visu_fx_out,nb_trame_max,id_last_trame FROM CONFIG;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				$ret=-1;
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$pr_in=$row[0];
					$fx_in=$row[1];
					$pr_out=$row[2];
					$fx_out=$row[3];
					$nb_trame_max=$row[4];
					$id_last_trame=$row[5];
				}
				else
				{
					$ret=-1;
				}
			}
			$requete = "SELECT count(*) FROM FIL_EAU;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				$ret=-1;
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$nb_trame=$row[0];
				}
				else
				{
					$ret=-1;
				}
			}
			$conn->deconnexion($db);
			return $ret;
		}
		public function rafraichir(&$entete1,&$entete2,&$entete3,&$entete4,&$dx1,&$dx2,&$dx3,&$comm_av,&$comm_now,&$elements)
		{
			$conn= new connexionBDD("localhost","soft","hxfr67ds");
			$db=$conn->connexion();
			mysql_select_db("IHM_FE",$db);
			$ret=0;
			$elements=array();
			$requete = "SELECT entete1,entete2,entete3,entete4,dx1,dx2,dx3,comm_av,comm_now FROM ENTETE;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				$ret=-1;
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$entete1=$row[0];
					$entete2=$row[1];
					$entete3=$row[2];
					$entete4=$row[3];
					$dx1=$row[4];
					$dx2=$row[5];
					$dx3=$row[6];
					$comm_av=$row[7];
					$comm_now=$row[8];
				}
				else
				{
					$ret=-1;
				}
			}
			$requete = "SELECT e.type,e.num,e.etat,e.protocole,e.direction,t.categorie FROM ETAT e LEFT JOIN TYPE t ON e.sous_type=t.code WHERE num<=96 ORDER BY type,num;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				$ret=-1;
			}
			else
			{
				$i=0;
				while($row=mysql_fetch_array($resultat))
				{
					$elements[$i]=new CElement();
					$elements[$i]->type=$row[0];
					$elements[$i]->num=$row[1];
					$elements[$i]->etat=$row[2];
					$elements[$i]->pr=$row[3];
					$elements[$i]->fx=$row[4];
					$elements[$i]->sous_type="";
					if($row[5]!=NULL)
					{
						$elements[$i]->sous_type=$row[5];
					}
					$i++;
				}
			}
			$conn->deconnexion($db);
			return $ret;
		}
		public function chargerFilDeLeau(&$elements,$id_last_write,$nb_max_trame,&$id_last_trame)
		{
			$conn= new connexionBDD("localhost","soft","hxfr67ds");
			$db=$conn->connexion();
			mysql_select_db("IHM_FE",$db);
			$elements=array();
			$ret=0;

			$requete = "SELECT id_last_trame FROM CONFIG;";	
			$resultat = mysql_query($requete);
			if($resultat===false)
			{
				$ret=-1;
			}
			else
			{
				if($row=mysql_fetch_array($resultat))
				{
					$id_last_trame=$row[0];
				}
				else
				{
					$ret=-1;
				}
			}
			
			if($id_last_write!=$id_last_trame)
			{
				if($id_last_write>$id_last_trame)
				{
					$limit=$nb_max_trame-1;
				}
				else
				{
					$limit=$id_last_trame;
				}

				$i=0;

				$requete = "SELECT comm,trame FROM FIL_EAU WHERE id>".$id_last_write." AND id<=".$limit." ORDER BY id ;";	
				$resultat = mysql_query($requete);
				if($resultat===false)
				{
					$ret=-1;
				}
				else
				{
					while($row=mysql_fetch_array($resultat))
					{
						$elements[$i]=new CElement();
						$elements[$i]->comm=$row[0];
						$elements[$i]->trame=$row[1];
						$i++;	
					}
				}

				if($id_last_write>$id_last_trame)
				{
					$requete = "SELECT comm,trame FROM FIL_EAU WHERE id<=".$id_last_trame." ORDER BY id ;";	
					$resultat = mysql_query($requete);
					if($resultat===false)
					{
						$ret=-1;
					}
					else
					{
						while($row=mysql_fetch_array($resultat))
						{
							$elements[$i]=new CElement();
							$elements[$i]->comm=$row[0];
							$elements[$i]->trame=$row[1];
							$i++;	
						}
					}
				}
			}
			$conn->deconnexion($db);
			return $ret;
		}
	}
?>
