<?php
require_once("CApplication.inc.php");
Class Profil
{
	/********************************************
	*
	*	Attributs de la classes Controleur
	*
	********************************************/
	private $id;
	private $libelle;
	private $accesParc;
	private $accesFullApplications;
	private $accesService;
	private $oApplications;
	private $description;
	private $login;
	private $password;
	private $affichages;


	/********************************************
	*
	*	Constructeur de la classe Controleur
	*
	********************************************/
	public function Profil()
	{
		$this->id=0;
		$this->libelle="";
		$this->accesParc="";
		$this->accesService=0;
		$this->accesFullApplications="";
		$this->oApplications="";
	}
	/********************************************
	*
	*	Accesseurs de la classe Controleur
	*
	********************************************/
	public function __get($propriete)
	{
		if(isset($this->$propriete))
		{
			return $this->$propriete;
		}
	}
	public function __set($propriete, $valeur)
	{
		if(isset($this->$propriete))
		{
			$this->$propriete = $valeur;
		}
	}
	public function chargerApplications()
	{
		$oPersistance = new Persistance();
		$ret = $oPersistance->chargerApplications($this->oApplications,$this->id,$this->accesFullApplications);
		return $ret;
	}
	public function initProfil($propertiesArr)
	{
		if(is_array($propertiesArr))
		{
			if (isset($propertiesArr["id"])) $this->id = $propertiesArr["id"];
			if (isset($propertiesArr["libelle"])) $this->libelle = $propertiesArr["libelle"];
			if (isset($propertiesArr["acces_parc"])) $this->accesParc = $propertiesArr["acces_parc"];
			if (isset($propertiesArr["options"])) $this->affichages = $propertiesArr["options"];
		}
	}
}
	
?>
